import { Client as RawClient, Instance as RawInstance } from '../rawclient';
import { SFNode } from './node';
export interface InstanceEvent {
    readonly timestamp: Date;
    readonly fqdn: string;
    readonly operation: string;
    readonly phase: string;
    readonly duration: number;
    readonly message: string;
}
interface PowerState {
    readonly current: string;
    readonly previous?: string;
    readonly updated: Date;
}
export declare class Instance {
    private rawClient;
    readonly id: string;
    name: string;
    cpus: number;
    memory: number;
    vdiPort: number;
    state: string;
    stateUpdated: Date;
    powerState: PowerState;
    events?: InstanceEvent[];
    private nodeName;
    node?: SFNode;
    constructor(rawClient: RawClient, instance: RawInstance);
    private useFieldsFrom;
    refreshFields(): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
    reboot(): Promise<void>;
    pause(): Promise<void>;
    unpause(): Promise<void>;
    getEvents(): Promise<InstanceEvent[]>;
    getNode(): Promise<SFNode>;
    getVDI(): Promise<string>;
}
export {};
