"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Instance = void 0;
var node_1 = require("./node");
function rawInstanceEventToInstanceEvent(ev) {
    var timestamp = ev.timestamp, fqdn = ev.fqdn, operation = ev.operation, phase = ev.phase, duration = ev.duration, message = ev.message;
    return {
        timestamp: new Date(timestamp * 1000),
        fqdn: fqdn,
        operation: operation,
        phase: phase,
        duration: duration,
        message: message,
    };
}
var Instance = /** @class */ (function () {
    function Instance(rawClient, instance) {
        this.rawClient = rawClient;
        this.id = instance.uuid;
        this.name = instance.name;
        this.cpus = instance.cpus;
        this.memory = instance.memory;
        this.vdiPort = instance.vdi_port;
        this.state = instance.state;
        this.stateUpdated = new Date(instance.state_updated * 1000);
        this.powerState = {
            current: instance.power_state,
            previous: instance.power_state_previous || undefined,
            updated: new Date(instance.power_state_updated * 1000),
        };
        this.nodeName = instance.node;
    }
    Instance.prototype.useFieldsFrom = function (instance) {
        this.name = instance.name;
        this.cpus = instance.cpus;
        this.memory = instance.memory;
        this.vdiPort = instance.vdi_port;
        this.state = instance.state;
        this.stateUpdated = new Date(instance.state_updated * 1000);
        this.powerState = {
            current: instance.power_state,
            previous: instance.power_state_previous || undefined,
            updated: new Date(instance.power_state_updated * 1000),
        };
        this.nodeName = instance.node;
    };
    Instance.prototype.refreshFields = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.useFieldsFrom;
                        return [4 /*yield*/, this.rawClient.getInstance(this.id)];
                    case 1:
                        _a.apply(this, [_b.sent()]);
                        // If they've refreshed fields, they probably want the latest
                        // events, so we invalidate our current list of events
                        this.events = undefined;
                        this.node = undefined;
                        return [2 /*return*/];
                }
            });
        });
    };
    Instance.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.rawClient.instanceAction(this.id, 'poweron')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Instance.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.rawClient.instanceAction(this.id, 'poweroff')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Instance.prototype.reboot = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.rawClient.instanceAction(this.id, 'reboot')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Instance.prototype.pause = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.rawClient.instanceAction(this.id, 'pause')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Instance.prototype.unpause = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.rawClient.instanceAction(this.id, 'unpause')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Instance.prototype.getEvents = function () {
        return __awaiter(this, void 0, void 0, function () {
            var events;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.events == null)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.rawClient.getInstanceHistory(this.id)];
                    case 1:
                        events = _a.sent();
                        this.events = events.map(rawInstanceEventToInstanceEvent);
                        _a.label = 2;
                    case 2: return [2 /*return*/, this.events];
                }
            });
        });
    };
    Instance.prototype.getNode = function () {
        return __awaiter(this, void 0, void 0, function () {
            var nodes, rawNode;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.node == null)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.rawClient.listNodes()];
                    case 1:
                        nodes = _a.sent();
                        rawNode = nodes.find(function (_a) {
                            var name = _a.name;
                            return name === _this.nodeName;
                        });
                        if (rawNode == null) {
                            throw new Error('Unable to get node for instance');
                        }
                        this.node = node_1.SFNode.fromRaw(this.rawClient, rawNode);
                        _a.label = 2;
                    case 2: return [2 /*return*/, this.node];
                }
            });
        });
    };
    Instance.prototype.getVDI = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ip;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getNode()];
                    case 1:
                        ip = (_a.sent()).ip;
                        return [2 /*return*/, ip + ":" + this.vdiPort];
                }
            });
        });
    };
    return Instance;
}());
exports.Instance = Instance;
