"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
var axios_1 = require("axios");
var jwt = require("jsonwebtoken");
// Method decorator to ensure a valid auth token
function authed(target, propertyKey, descriptor) {
    var originalMethod = descriptor.value;
    descriptor.value = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.needsTokenRefresh()) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.connect()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/, originalMethod.apply(this, args)];
                }
            });
        });
    };
    return descriptor;
}
var Client = /** @class */ (function () {
    function Client(url, apiKey, ns) {
        if (ns === void 0) { ns = 'system'; }
        this.tokenExpiry = new Date(0);
        this.apiKey = apiKey;
        this.ns = ns;
        this.httpClient = axios_1.default.create({ baseURL: url });
        this.httpClient.interceptors.response.use(function (_a) {
            var data = _a.data;
            return data;
        }, function (error) { return Promise.reject(error); });
    }
    Client.prototype.connect = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.canConnect()];
                    case 1:
                        if (!(_a.sent())) {
                            throw new Error('shakenfist-client: Unable to connect');
                        }
                        return [4 /*yield*/, this.authenticate()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Client.prototype.canConnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var message, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.httpClient.get('/')];
                    case 1:
                        message = _a.sent();
                        return [2 /*return*/, message === 'Shaken Fist REST API service'];
                    case 2:
                        err_1 = _a.sent();
                        return [2 /*return*/, false];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Client.prototype.authenticate = function () {
        return __awaiter(this, void 0, void 0, function () {
            var authToken;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getToken({ ns: this.ns, key: this.apiKey })];
                    case 1:
                        authToken = _a.sent();
                        this.setTokenExpiry(authToken);
                        this.httpClient.defaults.headers.common.Authorization = "Bearer " + authToken;
                        return [2 /*return*/];
                }
            });
        });
    };
    Client.prototype.getToken = function (_a) {
        var ns = _a.ns, key = _a.key;
        return __awaiter(this, void 0, void 0, function () {
            var token, err_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.httpClient.post('auth', {
                                namespace: ns,
                                key: key,
                            })];
                    case 1:
                        token = (_b.sent()).access_token;
                        return [2 /*return*/, token];
                    case 2:
                        err_2 = _b.sent();
                        throw new Error('shakenfist-client: Unable to authenticate');
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Client.prototype.setTokenExpiry = function (token) {
        var decoded = jwt.decode(token);
        if (decoded == null || typeof decoded === 'string') {
            throw new Error('shakenfist-client: Invalid JWT');
        }
        this.tokenExpiry = new Date(decoded.exp * 1000);
    };
    Client.prototype.needsTokenRefresh = function () {
        return this.tokenExpiry < new Date();
    };
    Client.prototype.listInstances = function () {
        return __awaiter(this, void 0, void 0, function () {
            var instances;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpClient.get('instances')];
                    case 1:
                        instances = _a.sent();
                        return [2 /*return*/, instances];
                }
            });
        });
    };
    Client.prototype.getInstance = function (uuid) {
        return __awaiter(this, void 0, void 0, function () {
            var instance;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpClient.get("instances/" + uuid)];
                    case 1:
                        instance = _a.sent();
                        return [2 /*return*/, instance];
                }
            });
        });
    };
    Client.prototype.instanceAction = function (uuid, action) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpClient.post("instances/" + uuid + "/" + action)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Client.prototype.getInstanceHistory = function (uuid) {
        return __awaiter(this, void 0, void 0, function () {
            var events;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpClient.get("instances/" + uuid + "/events")];
                    case 1:
                        events = _a.sent();
                        return [2 /*return*/, events];
                }
            });
        });
    };
    Client.prototype.listNodes = function () {
        return __awaiter(this, void 0, void 0, function () {
            var nodes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.httpClient.get('nodes')];
                    case 1:
                        nodes = _a.sent();
                        return [2 /*return*/, nodes];
                }
            });
        });
    };
    __decorate([
        authed
    ], Client.prototype, "listInstances", null);
    __decorate([
        authed
    ], Client.prototype, "getInstance", null);
    __decorate([
        authed
    ], Client.prototype, "instanceAction", null);
    __decorate([
        authed
    ], Client.prototype, "getInstanceHistory", null);
    __decorate([
        authed
    ], Client.prototype, "listNodes", null);
    return Client;
}());
exports.Client = Client;
